<?php

include('/usr/fallback/beroConf.php');

class apiCall {

	private $_name, $_get, $_post, $_execResult, $_execResultString;

	function __construct ($get = null, $post = null, $files = null) {
		$this->_name = 'beroCloudConfigure';
		$this->_get = $get;
		$this->_post = $post;
		$this->_execResult = true;
		$this->_execResultString = 'success';
	}

	function execute () {

		if (!in_array($this->_get['CloudEnable'], array('0', '1'))) {
			$this->_execResultString = 'error';
			$this->_execResult = false;
			return($this->_execResult);
		}

		$bc = new beroConf('root');
		$bc->set('root', 'cloud_enable', sqlite_escape_string($this->_get['CloudEnable']));
		$bc->set('root', 'cloud_key', sqlite_escape_string($this->_get['CloudKey']));

		return($this->_execResult);
	}

	function display () {
		return($this->_name . ':' . $this->_execResultString);
	}
}

?>
