<?php
chdir("..");
include "./includes/variables.php";
include "./misc/database.php";
$ba = new beroAri();
require_once("./includes/lang.php");
$apiUrl='https://'.$ba->get("cloudAddress").'/index.php?r=api';
function checkCloud(){
                global $apiUrl;
		$res=file_get_contents('/proc/cmdline');
		preg_match("/[^a-zA-Z0-9=]*?d=(?<serial>.+) /",$res,$serial);
		$serial=$serial['serial'];
		$url=$apiUrl.'/getAppListCheck';
		$ch = curl_init($url);

		$data = array('serial'=>$serial);

		//curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                curl_setopt($ch, CURLOPT_TIMEOUT, 20);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);

		$result = curl_exec($ch);
                $error=  curl_error($ch);
		curl_close($ch);
		$result.="beroNetF231";
		return array($serial,md5($result));
}

function getInstalledApps(){
	$table="<table class='contenttoc' id='table'>";
		if ($dh = opendir("/home/admin/apps/")) {
			while (($file = readdir($dh)) !== false) {
				//$ret.="found file: $file";
				if($file != "." && $file != "..")
					$table.="
					<tr>
						<td>".$file."</td>
						<td>
						<img src='./includes/images/delete.png' onclick=\"del('".$file."');\"></img>
						</td>
					</tr>";
			}
			closedir($dh);
		}
	$table .= "</table><br/>";



	return $table;
}

if (isset($_POST['get_installed'])){
    echo getInstalledApps();
}
if ($_POST['a']=='get_app'){

	$check=checkCloud();
	$serial=$check[0];
	$result=$check[1];

	$url=$apiUrl.'/getAppList';
	$ch = curl_init();

	$data = array('serial'=>$serial, 'app_key'=>$result);

	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_POST, 1);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
        curl_setopt($ch, CURLOPT_TIMEOUT, 20);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);

	$apps = curl_exec($ch);
        $error=  curl_errno($ch);

	$apps=unserialize($apps);
	if (count($apps)>=1 && is_array($apps)){
		$table="<table class='contenttoc'>";
                $table.="<tr><th>".MARKET_NAME."</th><th>".MARKET_DESCRIPTION."</th><th>".MARKET_CATEGORY."</th><th>".MARKET_VERSION."</th><th>".MARKET_PROVIDER."</th><th>".MARKET_PROVIDER_LINK."</th><th>".MARKET_DOCU_LINK."</th><th></th></tr>";
		foreach ($apps as $app){
                    ($app['providerLink']!=null) ? $providerLink="<a href='".$app['providerLink']."' target='_blank'>".$app['providerLink']."</a>":$providerLink="none";
                    ($app['docuLink']!=null) ? $docuLink="<a href='".$app['docuLink']."' target='_blank'>".$app['docuLink']."</a>":$docuLink="none";
			$table.="<tr><td>".$app['name']."</td><td>".$app['description']."</td><td>".$app['category']."</td><td>".$app['version']."</td><td>".$app['provider']."</td><td>".$providerLink."</td><td>".$docuLink."</td><td><input type='button' value='install' onclick='install(\"".$app['id']."\")'></td></tr>";
		}
		$table.="</table><br/>";
	}elseif (count($apps)==0 && is_array($apps)){
            $table="<font color='red'>There are no apps for this device</font><br/>";
        }else{
            $info = curl_getinfo($ch);
            //Wenn alive nicht funktioniert

            if ($info['http_code']==400 || $info['http_code']==401)
                $table="<font color='red'>Invalid app key</font><br/>";
            else
                $table="<font color='red'>Error, please check your cloud and network settings.</font><br/>";
        }
        curl_close($ch);
	echo $table;
}


if (isset($_POST['param'])){
	$check=checkCloud();
	$serial=$check[0];
	$result=$check[1];

	$url=$apiUrl.'/getAppList';
	$ch = curl_init();

	$data = array('serial'=>$serial, 'app_key'=>$result, 'idapp'=>$_POST['param']);

	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_TIMEOUT, 80);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);


	$apps = curl_exec($ch);
	curl_close($ch);
	file_put_contents("/tmp/app.tar.gz",$apps);

	$fileName="app.tar.gz";
	$image_dir = "/tmp/images";
	@mkdir($image_dir);
	if (is_dir($image_dir) && ($dh = opendir($image_dir))) {
			while (($file = readdir($dh)) != false) {
				if (strlen($file) > 7 && substr_compare($file, ".tar.gz", -7, 7) == 0) {
					$file_ = $image_dir . '/' . $file;
					if (strlen($file_) != 0 && file_exists($file_)) unlink($file_);
				}
				if ($file=="content.txt"){
					$file_ = $image_dir . '/' . $file;
					if (strlen($file_) != 0 && file_exists($file_)) unlink($file_);
				}
			}
		}
			$split_ext=explode(".",$fileName);

			if ($split_ext[count($split_ext)-1]=="gz" && $split_ext[count($split_ext)-2]=="tar" && count($split_ext)>=3){
			$upload_file = $image_dir . '/' . $fileName;
		if ((filesize("/tmp/".$fileName)/1024)/1024<=7.9){
				system ("/bin/mv /tmp/".$fileName." ".$image_dir);
				if (strlen($fileName) != 0 && file_exists($image_dir . '/' . $fileName)) system("/usr/sbin/userapp_pkg_install.sh $fileName >/var/log/cloud-updateFW.log");


			}
		}

	echo getInstalledApps();
}

if (isset($_POST['del_param'])){
	exec("/usr/local/sbin/userapp_uninstall.sh ".$_POST['del_param']);

	echo getInstalledApps();
}
if (isset($_POST['menu'])){
	$directory_not_empty = FALSE;
	if ($dh = @opendir("/home/admin/apps/")) {
        while (($file = readdir($dh)) !== false) {
            if($file != "." && $file != "..")
				$directory_not_empty = TRUE;
		}
        closedir($dh);
    }

    $app_menu="";
    if ($directory_not_empty) {
        if ($dh = @opendir("/home/admin/apps/")) {
            while (($file = readdir($dh)) !== false) {
                //$ret.="found file: $file";
                if($file != "." && $file != "..")
                    $app_menu.="<li><a href='/userapp/$file/index.php'>".$file."</a></li>";
            }
            closedir($dh);
        }
    }
	$app_menu.="<li><a href='index.php?m=market' id='market'>".MENU_MARKET."</a></li></ul>";
	echo $app_menu;
}
?>
